<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Teknisa\GER\Controllers\Consplan;
use Teknisa\GER\Services\NewCode;
use Zeedhi\Framework\DTO;


class Pla02700 extends \Zeedhi\Framework\Controller\Report {

    protected $novoCodigo;
    protected $procedureCardMes;
    protected $entityManager;
    protected $environment;
    protected $parameterBagColumns;
    protected $sequencial;
    protected $nrconsplan;
    protected $qr2Strategy;
    protected $birtStrategy;
    protected $util;

    public function __construct($reportService, Consplan $consplan, NewCode $novoCodigo, $entityManager, $environment, $parameterBagColumns, $qr2Strategy, $birtStrategy, $util) {

        $this->consplan      = $consplan;
        $this->novoCodigo    = $novoCodigo;
        $this->entityManager = $entityManager;
        $this->environment   = $environment;
        $this->qr2Strategy   = $qr2Strategy;
        $this->birtStrategy  = $birtStrategy;
        $this->util          = $util;

        parent::__construct($reportService, $environment, $parameterBagColumns);
    }

    protected $reportMapping = array (
    
        'PLA02700' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
            array (
                'CDDIETA'       => 'P_CDDIETA',
                'IDIMPCOMEN'    => 'P_IMPCOMENS',
                'NRSEQTRABCARD' => 'P_NRTRABCARDMES',
                'MENS'          => 'P_MENS',
                'CDFILIAL1'     => 'P_CDFILIAL',
                'IMPNMFANTA'    => 'P_IMPNMFANTA',
                'NRORG'         => 'P_NRORG'
            ),
        ),
    
        'PLA02701' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
            array (
                'CDDIETA'       => 'P_CDDIETA',
                'NRSEQTRABCARD' => 'P_NRTRABCARDMES',
                'MENS'          => 'P_MENS',
                'CDFILIAL1'     => 'P_CDFILIAL',
                'IMPNMFANTA'    => 'P_IMPNMFANTA',
                'NRORG'         => 'P_NRORG'
            ),
        ),

        'PLA02702' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
            array (
                'CDDIETA'      => 'P_CDDIETA',
                'LISTASERVICO' => 'P_SERVICOS',
                'DTMESINIC'    => 'P_DTMESINI',
                'DTMESFINA'    => 'P_DTMESFIN',
                'CDFILIAL1'    => 'P_CDFILIAL',
                'NRORG'        => 'P_NRORG',
                'CDPICTPROD'   => 'P_CDPICTPROD',
                'IMPNMFANTA'   => 'P_IMPNMFANTA',
                'CDPICTPRAT'   => 'P_CDPICTPRAT'
            ),
        ),

        'PLA02703' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
            array (
                'CDDIETA'      => 'P_CDDIETA',
                'LISTASERVICO' => 'P_SERVICOS',
                'DTMESINIC'    => 'P_DTMESINI',
                'DTMESFINA'    => 'P_DTMESFIN',
                'CDFILIAL1'    => 'P_CDFILIAL',
                'NRORG'        => 'P_NRORG',
                'CDPICTPROD'   => 'P_CDPICTPROD',
                'IMPNMFANTA'   => 'P_IMPNMFANTA',
                'CDPICTPRAT'   => 'P_CDPICTPRAT'
            ),
        ),

        'PLA02704' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
            array (
                'CDDIETA'       => 'P_CDDIETA',
                'IDIMPCOMEN'    => 'P_IMPCOMENS',
                'NRSEQTRABCARD' => 'P_NRTRABCARDMES',
                'LISTAFILI'     => 'P_FILIAIS',
                'MENS'          => 'P_MENS',
                'CDFILIAL1'     => 'P_CDFILIAL',
                'IMPNMFANTA'    => 'P_IMPNMFANTA',
                'NRORG'         => 'P_NRORG'
            ),
        ),
    
        'PLA02705' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
            array (
                'IDIMPCOMEN'    => 'P_IMPCOMENS',
                'TPCUSTO'       => 'P_NRTIPOCUSTO',
                'NRSEQTRABCARD' => 'P_NRTRABCARDMES',
                'CDDIETA'       => 'P_CDDIETA',
                'CDFILIAL'     => 'P_CDFILIAL',
                'DTMESINIC'     => 'P_DTMESINI',
                'DTMESFINA'     => 'P_DTMESFIN',
                'MENS'          => 'P_MENS',
                'IMPNMFANTA'    => 'P_IMPNMFANTA',
                'NRORG'         => 'P_NRORG'
            ),
        ),

        'PLA02707' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
            array (
                'CDDIETA'       => 'P_CDDIETA',
                'IDIMPCOMEN'    => 'P_IMPCOMENS',
                'NRSEQTRABCARD' => 'P_NRTRABCARDMES',
                'CDFILIAL'     => 'P_CDFILIAL',
                'MENS'          => 'P_MENS',
                'DTMESINIC'     => 'P_DTMESINI',
                'DTMESFINA'     => 'P_DTMESFIN',
                'TPCUSTO'       => 'P_NRTIPOCUSTO',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'IMPNMFANTA'    => 'P_IMPNMFANTA',
                'NRORG'         => 'P_NRORG'
            ),
        ),

        'PLA02708' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
            array (
                'CDOPERADOR' => 'P_CDOPERADOR',
                'CDFILIAL'   => 'P_CDFILIAL',
                'CDSERVFILI' => 'P_CDSERVFILI',
                'DTMESINIC'  => 'P_DTINICIAL',
                'DTMESFINA'  => 'P_DTFINAL',
                'TPCUSTO'    => 'P_NRTIPOCUSTO',
                'IMPNMFANTA' => 'P_IMPNMFANTA',
                'CDGRUPFILI' => 'P_CDGRUPFILI',
                'NRORG'      => 'P_NRORG'
            )
            ),
        'PLA02709' => 
            array (
                'strategy' => 'BIRT',
                'parameterMapping' => 
                array (
                    'CDDIETA'       => 'P_CDDIETA',
                    'IDIMPCOMEN'    => 'P_IMPCOMENS',
                    'NRSEQTRABCARD' => 'P_NRTRABCARDMES',
                    'MENS'          => 'P_MENS',
                    'CDFILIAL1'     => 'P_CDFILIAL',
                    'IMPNMFANTA'    => 'P_IMPNMFANTA',
                    'NRORG'         => 'P_NRORG'
                )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        if($row['REPORT_CODE'] !== 'PLA02708' ) {
            $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
            $listaServ  = $row['LISTASERV'];
            $cdoperador = $row['CDOPERADOR'];
            $cdfilial   = $row['LISTAFILI'];
            $row['NRORG'] = $this->environment->getNrOrg();
            $cdgrupfili = $row['CDGRUPFILI'];
            
            if($row['REPORT_CODE'] == 'PLA02705' || $row['REPORT_CODE'] == 'PLA02707') {
                $row['CDFILIAL1'] = $row['CDFILIAL'];
                $listaFili = $row['CDFILIAL1'];
            } else {
                $listaFili  = $row['LISTAFILI'];
            }
            
            if($row['REPORT_CODE'] == 'PLA02702' OR $row['REPORT_CODE'] == 'PLA02703'){
                
                $filiserv = $this->getServFili($listaFili, $listaServ ,$cdoperador, $cdgrupfili);
                $row['LISTASERVICO'] = $this->geraListaServico($filiserv, $row['NRORG']);
            }
    
            $this->sequencial = $this->novoCodigo->getCodeByTableName('LISTA', $row['NRORG']);
            $this->sequencial = 'E' . substr($this->sequencial, -9);
            $this->criarLista($this->sequencial, $listaFili, $listaServ, $cdoperador, $cdgrupfili);
            
            $connection = $this->entityManager->getConnection();
            $procedureCardMes = new StoredProcedure($connection, 'TRAB_RELCARDMES');
            $procedureCardMes->addParam(new Param('P_NRSEQTRABCARD', Param::PARAM_INPUT, $this->sequencial,      Param::PARAM_TYPE_STR));
            $procedureCardMes->addParam(new Param('P_NRLISTASERV',   Param::PARAM_INPUT, $this->sequencial,      Param::PARAM_TYPE_STR));
            $procedureCardMes->addParam(new Param('P_DTMESINIC',     Param::PARAM_INPUT, $row['DTMESINIC'],      Param::PARAM_TYPE_STR));
            $procedureCardMes->addParam(new Param('P_DTMESFIM',      Param::PARAM_INPUT, $row['DTMESFINA'],      Param::PARAM_TYPE_STR));
            $procedureCardMes->addParam(new Param('P_IDNOMEFANT',    Param::PARAM_INPUT, $row['IMPNMFANTA'],     Param::PARAM_TYPE_STR));
            $procedureCardMes->addParam(new Param('P_IDIMPDIASSEM',  Param::PARAM_INPUT, $row['IMPDIASSEMCARD'], Param::PARAM_TYPE_STR));
            $procedureCardMes->addParam(new Param('P_QTCOLUNA',      Param::PARAM_INPUT, $row['QTCOLUNA'],       Param::PARAM_TYPE_INT));
            $procedureCardMes->execute();
     
            $row['NRSEQTRABCARD'] = $this->sequencial;
            if ($row['REPORT_CODE'] == 'PLA02707') {
                $row['NRCONSPLAN'] = $this->executaProcedureConsumoPlanejado($request, $response, $row, $listaFili);
            }
            $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        } else {
            $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
            $row["__report_name"] = strtoupper($row["REPORT_CODE"]);
            $row["NRORG"] = $this->environment->getNrorgTrab();
            
            $servicos = [];
            
            if(is_array($row["NMSERVICO"])){
                foreach($row["NMSERVICO"] as $serv){
                    array_push($servicos, $serv['CDFILIAL'].$serv['CDSERVFILI']);
                };
            }
            
            $row['CDFILIAL'] = $row["ALLCDFILIAL"] === "S"? 'T': $this->criarListaValores(implode('_', $row["NMFILIAL"]));
            $row['CDSERVFILI'] = $row["ALLCDSERVFILI"] === "S"? 'T': $this->criarListaValores(implode('_', $servicos));
            $row['CDGRUPFILI'] = isset($row['CDGRUPFILI']) && $row['CDGRUPFILI'] != "" && $row['CDGRUPFILI'] != "T"? $row['CDGRUPFILI']: null;
        }
    }

    public function executaProcedureConsumoPlanejado ($request, $response, $row, $listaFili) {
        $this->nrconsplan = $this->novoCodigo->getCodeByTableName('CONSPLAN'.$row['CDFILIAL'], $row['NRORG']);
        $connection = $this->entityManager->getConnection();
        $procedureConsumoPlanejado = new StoredProcedure($connection, 'CONSUMO_PLANEJADO_PLA');
        $procedureConsumoPlanejado->addParam(new Param('P_FILIAL',       Param::PARAM_INPUT, $listaFili,         Param::PARAM_TYPE_STR));
        $procedureConsumoPlanejado->addParam(new Param('P_SERVICOS',     Param::PARAM_INPUT, $row['LISTASERV'],  Param::PARAM_TYPE_STR));
        $procedureConsumoPlanejado->addParam(new Param('P_DTINICIAL',    Param::PARAM_INPUT, $row['DTMESINIC'],  Param::PARAM_TYPE_STR));
        $procedureConsumoPlanejado->addParam(new Param('P_DTFINAL',      Param::PARAM_INPUT, $row['DTMESFINA'],  Param::PARAM_TYPE_STR));
        $procedureConsumoPlanejado->addParam(new Param('P_IDARQUIVO',    Param::PARAM_INPUT, "C",                Param::PARAM_TYPE_STR));
        $procedureConsumoPlanejado->addParam(new Param('P_IDPRODUTOS',   Param::PARAM_INPUT, "CFP",              Param::PARAM_TYPE_STR));
        $procedureConsumoPlanejado->addParam(new Param('P_IDSEPPRATO',   Param::PARAM_INPUT, "P",                Param::PARAM_TYPE_STR));
        $procedureConsumoPlanejado->addParam(new Param('P_PEACRESCIMO',  Param::PARAM_INPUT, 0,                  Param::PARAM_TYPE_INT));
        $procedureConsumoPlanejado->addParam(new Param('P_IDARREDOND',   Param::PARAM_INPUT, "N",                Param::PARAM_TYPE_STR));
        $procedureConsumoPlanejado->addParam(new Param('P_NRCONSPLAN',   Param::PARAM_INPUT, $this->nrconsplan,  Param::PARAM_TYPE_STR));
        $procedureConsumoPlanejado->addParam(new Param('P_CDPRODUTOINI', Param::PARAM_INPUT, "0",                Param::PARAM_TYPE_STR));
        $procedureConsumoPlanejado->addParam(new Param('P_CDPRODUTOFIN', Param::PARAM_INPUT, "zzzzzzzzzz",       Param::PARAM_TYPE_STR));
        $procedureConsumoPlanejado->addParam(new Param('P_CDOPERADOR',   Param::PARAM_INPUT, $row['CDOPERADOR'], Param::PARAM_TYPE_STR));
        $procedureConsumoPlanejado->addParam(new Param('P_STDTINICIAL',  Param::PARAM_INPUT, "",                 Param::PARAM_TYPE_STR));
        $procedureConsumoPlanejado->addParam(new Param('P_STDTFINAL',    Param::PARAM_INPUT, "",                 Param::PARAM_TYPE_STR));
        $procedureConsumoPlanejado->execute();

        return $this->nrconsplan;
    }
    
    public function geraListaServico($filiserv, $nrorg){
        $nrlistaServico = $this->novoCodigo->getCodeByTableName('LISTA_SERVICO', $nrorg);
        $sql = "INSERT INTO LISTA_SERVICO (NRLISTA, CDFILIAL, CDSERVFILI, NMSERVICO, NRORG) VALUES (:NRLISTA, :CDFILIAL, :CDSERVFILI, :NMSERVICO, :NRORG)";
        
        foreach ($filiserv as $servicoFilial) {
            if(!empty($servicoFilial)){
                $this->entityManager->beginTransaction();
                $params = array(
                    "NRLISTA" => $nrlistaServico,
                    "CDFILIAL" => $servicoFilial['CDFILIAL'],
                    "NRORG" => $nrorg,
                    "CDSERVFILI" => $servicoFilial['CDSERVFILI'],
                    "NMSERVICO" => $servicoFilial['NMSERVICO']
                );
                try{
                    $this->entityManager->getConnection()->prepare($sql)->execute($params);
                    $this->entityManager->commit();
                }catch (\Exception $e) {
                    $this->entityManager->rollback();
                }
            }
        }
        return $nrlistaServico;
    }
    
    public function getServFili($listaFili, $listaServ ,$cdoperador, $cdgrupfili){
        $params = array(
            'P_CDFILIAL'   => $listaFili,
            'P_CDSERVFILI' => $listaServ,
            'P_CDOPERADOR' => $cdoperador,
            'P_CDGRUPFILI' => $cdgrupfili
        );
        $sql = "SELECT DISTINCT SE.CDFILIAL||SE.CDSERVFILI AS CDFILISERV, SE.CDSERVFILI, SE.CDFILIAL, SE.NMSERVICO
                  FROM SERVICO SE, FILIOPER FO, FILGRUPFILI GF
                WHERE (INSTR(:P_CDFILIAL, SE.CDFILIAL) <> 0 OR :P_CDFILIAL = 'T')
                  AND ((:P_CDGRUPFILI = GF.CDGRUPFILI) OR :P_CDGRUPFILI    = 'T')
                  AND (INSTR(:P_CDSERVFILI, SE.CDFILIAL  ||SE.CDSERVFILI) <> 0 OR :P_CDSERVFILI    = 'T')
                  AND (SE.CDFILIAL    = FO.CDFILIAL )
                  AND (FO.CDOPERADOR  = :P_CDOPERADOR)
                  AND (GF.CDFILIAL(+) = FO.CDFILIAL)";
        try{
            return $this->entityManager->getConnection()->fetchAll($sql, $params);    
        }catch(\Exception $e) {
            throw $e;
        }      
        
    }
    public function criarLista($nrlista, $listaFili, $listaServ ,$cdoperador, $cdgrupfili) {
        try {
            $result = $this->getServFili($listaFili, $listaServ ,$cdoperador, $cdgrupfili);
           
            foreach($result as $row) {
                $sql = "INSERT INTO LISTA (NRLISTA, CDLISTA) VALUES (:NRLISTA, :CDLISTA)";

                $query = $this->entityManager->getConnection()->prepare($sql);
                $query->bindValue("NRLISTA", $nrlista);
                $query->bindValue("CDLISTA", $row['CDFILISERV']);
                $query->execute();
                
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    //Criado no TCO: cria lista de valores recebendo string como parametro
    public function criarListaValores($valores){
        if(strlen($valores) <= 4000){
            return $valores;
        }else{
            $lista = explode('_',$valores);
            $nrlista = $this->novoCodigo->getCodeByTableName('LISTA', $this->environment->getNrorgTrab(), 1, 10, false);
            try{
                foreach($lista as $key){
                    $this->insertLista($nrlista, $key);
                }
                return "_NRLISTA=".$nrlista;
            } catch(\Exception $e){
                throw $e;
            }
        }
    }
    
    //Criado no TCO: insere lista no banco
    public function insertLista($nrlista, $cdlista) {
        $connection = $this->entityManager->getConnection();
        $params = array(
            "NRLISTA" => $nrlista,
            "CDLISTA" => $cdlista,
            "NRORG" => $this->environment->getNrorgTrab()
        );
        
        $sql = "INSERT INTO LISTA (NRLISTA, CDLISTA, NRORG) VALUES (:NRLISTA, :CDLISTA, :NRORG)";
        $query = $connection->prepare($sql);
        $query->execute($params);
    }
    
}