<?php

namespace Teknisa\PLA\Modules\Prato\Controllers;

use Zeedhi\Framework\DTO;

use Zeedhi\Framework\DependencyInjection\InstanceManager;
use Zeedhi\Framework\Util\QuerySelector;

class Pla13100PadraoGrupoDePrato {


    protected $environment;
    protected $connection;
    protected $crudService;

    public function __construct($environment, $connection, $crudService) {
        $this->environment = $environment;
        $this->connection  = $connection;
        $this->crudService = $crudService;
    }

    public function save(DTO\Request\Row $request, DTO\Response $response) {
        $connection = InstanceManager::getInstance()->getService('entityManager')->getConnection();
        $row = $request->getRow();
        $dataSet = $row['rowsChanged'];
        $queryUpdateGroupPlate = "UPDATE GRUPOPRATO SET 
                                        NMGRUPOPRATO = :NEW_NMGRUPOPRATO,
                                        DTULTATU = SYSDATE, 
                                        NRORGULTATU = :NRORG, 
                                        CDOPERULTATU = :CDOPERADOR
                                    WHERE 
                                        CDGRUPOPRATO = :CDPADGRUPOPRATO AND 
                                        IDTIPORESTRICAO = :IDTIPORESTRICAO AND 
                                        NRORG =:NRORG";
        $queryPostgre = "
            UPDATE GRUPOPRATO SET 
                NMGRUPOPRATO = :NEW_NMGRUPOPRATO,
                DTULTATU = CLOCK_TIMESTAMP(), 
                NRORGULTATU = :NRORG, 
                CDOPERULTATU = :CDOPERADOR
            WHERE 
                CDGRUPOPRATO = :CDPADGRUPOPRATO AND 
                IDTIPORESTRICAO = :IDTIPORESTRICAO AND 
                NRORG =:NRORG
        ";                                
        $this->connection->beginTransaction();
        try {
            $this->crudService->save('padgrupoprato', $dataSet);
            foreach($dataSet as $cRow){
               
                $params = array(
                    'NEW_NMGRUPOPRATO' => $cRow['NMPADGRUPOPRATO'],
                    'CDPADGRUPOPRATO'  => $cRow['CDPADGRUPOPRATO'],
                    'IDTIPORESTRICAO'  => $row['IDTIPORESTRICAO'],
                    'NRORG'            => $this->environment->getNrOrg(),
                    'CDOPERADOR'       => $this->environment->getCdOperador()
                );
                $arrayQueries = array (
                    'default'   => $queryUpdateGroupPlate,
                    'pdo_pgsql' => $queryPostgre
                );
                $query = QuerySelector::getQueryByDriver($connection, $arrayQueries);
                $stmt = $this->connection->prepare($query);
                $stmt->execute($params);
                
            }
            $this->connection->commit();
        } catch (\Exception $e){
            $this->connection->rollback();
            $response->setError($e->getMessage());
        }
    }
} 
